unit uMain;

interface

uses
	uDForm,
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls, uDButton, ExtCtrls, TeeProcs, TeEngine, Chart, Series;

type
	TfMain = class(TDForm)
		DButtonKanpsack: TDButton;
		DButtonVessel: TDButton;
		MemoMes: TMemo;
		DButtonTraveller: TDButton;
		Chart: TChart;
		procedure FormCreate(Sender: TObject);
		procedure DButtonKanpsackClick(Sender: TObject);
		procedure DButtonVesselClick(Sender: TObject);
		procedure DButtonTravellerClick(Sender: TObject);
		procedure FormResize(Sender: TObject);
	private
		{ Private declarations }
		procedure AddMes(Mes: string);
	public
		{ Public declarations }
	end;

var
	fMain: TfMain;

implementation

{$R *.dfm}
uses
	Math,
	uAdd, uFiles, uStrings, uInput, uError, uSysInfo, uSorts, uHTML, uDBitmap, uDChart;

// ********************************* Traveller *******************************

const
	MaxMatrix = 4095;
var
	// 2187x2187
	Matrix: array[0..MaxMatrix, 0..MaxMatrix] of U2;
	Enableds: array[0..MaxMatrix, 0..MaxMatrix] of U1;
	MaxXY: SG;
	// cesta
	Way, StartWay: array[0..MaxMatrix] of SG; // index dalsiho uzlu na ceste pro dany uzel
	WayCount: SG;
	WayValue: SG;
	BestWayValue: SG;

	Unused0, Unused1: array[0..MaxMatrix] of U4;
	Unused0Count, Unused1Count: SG;
const
	NoWay = High(Matrix[0, 0]);
	NoTown = High(Way[0]);

{
function NextIndex(Index: SG): SG;
begin
	if Index >= MaxXY then
		Result := 0
	else
		Result := Index + 1;
end;

function Index(Index: SG): SG;
begin
	if Index > MaxXY then
		Result := Index - MaxXY - 1
	else
		Result := Index;
end;
}
{$ifopt d+}
procedure CheckWay;
var i, c: SG;
begin
	i := 0;
	c := 0;
	while True do
	begin
		i := Way[i];
		Inc(c); if c > WayCount then
		begin
			IE(5454);
			Exit;
		end;
		if i = 0 then Break;
	end;
	if c <> WayCount then
		IE(4353);
end;
{$endif}

var
	Beta, MinTemp, MaxTemp: FG;
	Inter: U4;
	PosCount, PosCountO, PosCountV: U8;
	ASeries: array[0..2] of TLineSeries;
	StartWayValue: SG;

procedure Zihani;
var
	Temp: FG;

	function NewSolution: BG;
	label LAgain;
	var
		Index0, Index1: SG;
		Value0, Value1: SG;
		i: SG;
		Dif, Dif2: SG;
		Last, T0, T1, T2: SG;
		SwapCan: SG;
		NF: SG;
	begin
		Inc(PosCountO);
		SwapCan := 0;
		Result := True;
		Unused0Count := MaxXY + 1;
		FillOrderU4(Unused0[0], Unused0Count);

		NF := 0;
		while True do
		begin
			Inc(PosCountV);
			while (Unused0Count > 0) do
			begin
				Index0 := Random(Unused0Count);

				Move(Unused0[Index0 + 1], Unused0[Index0], SizeOf(Unused0[0]) * (Unused0Count - 1 - Index0));
				Dec(Unused0Count);
				Index0 := Unused0[Index0];

	//			FillOrderU4(Unused0[0], Unused0Count);
				Unused1Count := 0;
				for i := 0 to MaxXY do
				begin
//					if (Way[i] <> Way[Index0]) and (Way[i] <> Way[Way[Index0]]) and (Way[Index0] <> Way[Way[i]]) then
					if (i <> Index0) and (i <> Way[Index0]) and (Index0 <> Way[i]) then
					if (Matrix[Index0, i] <> NoWay)
					and (Matrix[Way[Index0], Way[i]]<> NoWay) then
					begin
						Unused1[Unused1Count] := i;
						Inc(Unused1Count);
					end;
				end;

				while (Unused1Count > 0) do
				begin
					Index1 := Random(Unused1Count);

					Move(Unused1[Index1 + 1], Unused1[Index1], SizeOf(Unused1[0]) * (Unused1Count - 1 - Index1));
					Dec(Unused1Count);
					Index1 := Unused1[Index1];

					Value0 := Matrix[Index0, Index1];
					Value1 := Matrix[Way[Index0], Way[Index1]];

					if (Value0 <> NoWay) and (Value1 <> NoWay) then
					begin
						// possible solution
						Dif := Value0 + Value1
							- Matrix[Index0, Way[Index0]]
							- Matrix[Index1, Way[Index1]];

						Dif2 := Dif; //WayValue - BestWayValue;

						// Prob
						if (Dif2 < 0) or (Exp(-Dif2 / Temp) > Random(1000000) / 1000000) then
						begin
							Inc(SwapCan);
//							NF := 0;
							Inc(WayValue, Dif);
							if WayValue < BestWayValue then
							begin
								BestWayValue := WayValue;
								ASeries[2].AddXY(PosCountV, BestWayValue);
							end;

							if (Dif < 0) then
							begin
//								ASeries[0].AddXY(PosCountV, WayValue);
//								fMain.AddMes('Better Solution Found, Value = ' + NToS(WayValue));
							end
							else if Dif > 0 then
//								fMain.AddMes('Worst Solution Accepted, Value = ' + NToS(WayValue));

							if Index0 > Index1 then Exchange(Index0, Index1);

							{$ifopt d+}CheckWay;{$endif}

							Last := Index1;
							T0 := Way[Index1];
							T1 := Way[Index0];

							while True do
							begin
								T2 := Way[T1];
								Way[T1] := T0;
								if T1 = Last then Break;
								T0 := T1;
								T1 := T2;
							end;

							Way[Index0] := Index1;
							{$ifopt d+}CheckWay;{$endif}
							goto LAgain;
(*							for i := 0 to MaxXY do
							begin
								// D???
								if (((Index0 > Index1) and ((i > Index0) or (i < NextIndex(Index1))))
								or (((Index0 < Index1) and ((i > Index0) and (i < NextIndex(Index1)))))) then
									Way[i] := Way[Index(Index0+Index1+1-i)]
								else
									Way[i] := Way[i];
							end;  *)
//							BestValue := Value;
						end;
					end;
				end;
			end;
			LAgain:
			Inc(NF); if NF > 1 then Break;
		end;

		if SwapCan = 0 then
		begin
			fMain.AddMes('Swap not found ' + NToS(BestWayValue));
			Result := False;
		end;
	end;

var i: SG;
begin
	ASeries[2].AddXY(PosCountV, BestWayValue);
	for i := 0 to Inter - 1 do
	begin
		// Ochlazovani
		Temp := MaxTemp;
		while True do
		begin
	//		while True do
			begin
				// Modify solution
				if NewSolution = False then
					Break;
			end;
			ASeries[0].AddXY(PosCountV, Temp * StartWayValue / MaxTemp);
			ASeries[1].AddXY(PosCountV, WayValue);
			Temp := Temp * Beta;
			if Temp < MinTemp then
			begin
				fMain.AddMes('Cooled at ' + NToS(WayValue));
				Break;
			end;
		end;
	end;
	ASeries[2].AddXY(PosCountV, BestWayValue);
end;

procedure TfMain.DButtonTravellerClick(Sender: TObject);
label LSkip;
type
	TParam = (paNone, paTMax, paTMin, paBeta, paInter);
const
	FileNames: array[0..12] of string = (
		'M',
		'Testik',
		'B',
		'A',
		'C',
		'D',
		'E',
		'F',
		'G',
		'H',
		'I',
		'J',
		'K');

	ParamNameFile: array[TParam] of string = ('', 'TMax', 'TMin', 'Beta', 'Interakce');
	ParamNameHTML: array[TParam] of string = ('', 'T<sub>MAX</sub>', 'T<sub>MIN</sub>', '&beta;', 'Interakce');
{	ParamNameCz: array[TParam] of string = (
		'minimln teplota',
		'maximln teplota',
		'beta',
		'interakc');}
type
	TVariantion = (vaNoWay, va10000, va10);
const
	VariantionNameFile: array[TVariantion] of string = ('INF', '10 000', '10');
	VariantionNameHTML: array[TVariantion] of string = ('&infin;', '10 000', '10');
var
	Variantion: TVariantion;
var
	FileIndex: SG;
	Line: string;
	InLineIndex: SG;
	FileName: TFileName;
	x, y: SG;
//	Matrix: array of array of U1; // 16MB
//	Way: array of SG;
	i: SG;
	C, TotalC: UG;
	MaxC: UG;

	Next, Actual, NowStart: SG;
	Start: array[0..MaxMatrix] of SG;
	StartCount: SG;
	T0, T1, T2, Last: SG;

	BestValue, WorstValue, EdgeValue: SG;
	BestNext, WorstNext: SG;
	BestCount, WorstCount: UG;
	SolutionFound: BG;
	Param: TParam;
	Bmp: TDBitmap;

	NF: SG;

	InternalName: string;
	HTML: THTML;
	Tenuity: U8;
begin
	for i := 0 to Length(ASeries) - 1 do
	begin
		ASeries[i] := TLineSeries.Create(Self);
		ASeries[i].Pointer.Visible := True;
		ASeries[i].Pointer.Style := psTriangle;
	end;
	ASeries[0].Title := 'Teplota';
	ASeries[1].Title := 'Dlka cesty';
	ASeries[2].Title := 'Nejkrat dlka cesty';

	HTMLStyle(Chart);
	Chart.LeftAxis.Logarithmic := False;
	Chart.LeftAxis.Title.Caption := 'Dlka cesty / Teplota';
	Chart.BottomAxis.Title.Caption := 'Poet interac';
	Chart.ClientWidth := 800;
	Chart.ClientHeight := 600;


	for i := Length(ASeries) - 1 downto 0 do
		Chart.AddSeries(ASeries[i]);

	HTML := THTML.Create(WorkDir + 'Table5.html');
	HTML.Title := 'Tabulka eench instanc a parametr';
	HTML.AddBody('<table border="1">');
	HTML.AddBody('<tr>');
	HTML.AddHeadCell('loha');
	HTML.AddHeadCell('Varianta', True);
	HTML.AddHeadCell('Poet<br/> mst', True);
	HTML.AddHeadCell('Hustota<br/> [%]', True);
	for Param := paTMax{Low(ParamNameHTML)} to High(ParamNameHTML) do
		HTML.AddHeadCell(ParamNameHTML[Param], True);

	HTML.AddHeadCell('Poten<br/> dlka', True);
	HTML.AddHeadCell('Koncov<br/> dlka', True);
	HTML.AddHeadCell('Poet<br/> stav<br/> (Potek)', True);
	HTML.AddHeadCell('Poet<br/> stav<br/> (Konec)', True);
	HTML.AddBody('</tr>');
	for FileIndex := 0 to Length(FileNames) - 1 do //0 to 12 do // max 12
	begin
		FillChar(Matrix, SizeOf(Matrix), NoWay);
		// Read
		FileName := WorkDir + 'tspbench\' + FileNames[FileIndex] + '.txt';
		AddMes(ExtractFileName(FileName) + ' readed *******************');
		Line := ReadStringFromFile(FileName);
		InLineIndex := 1;
		InternalName := ReadToChar(Line, InLineIndex, CharLF);

		MaxXY := 0;
		x := 0;
		y := 0;
		for InLineIndex := InLineIndex to Length(Line) do
		begin
			if Line[InLineIndex] in [CharCR] then
			else if Line[InLineIndex] in [CharLF] then
			begin
				x := 0;
				Inc(y);
			end
			else
			begin
				Matrix[x, y] := HexValue[Line[InLineIndex]];
				Inc(x);
				if x > MaxXY then MaxXY := x;
			end;
		end;
		if (y < MaxXY - 1) or (y > MaxXY + 1) then
		begin
//			MaxXY := y;
			IOErrorMessage(FileName, 'Matrix is not square');
			Continue;
		end;
		Dec(MaxXY);
		Line := '';
		AddMes(NToS(MaxXY + 1) + ' towns');

		for Variantion := Low(Variantion) to {Low(Variantion)}High(Variantion) do
		begin
			// 3 druhy zadani
			for y := 0 to MaxXY do
			begin
				for x := 0 to MaxXY do
				begin
					{		Neexistujc hrany (tzn. hrany s hodnotu '0') zpracujte temi zpsoby:
					Hrany existuj a maj hodnotu 10.
					Hrany existuj a maj hodnotu 10000.
					Hrany neexistuj.}
					if x <> y then
						case Variantion of
						vaNoWay: if Matrix[x, y] = 0 then Matrix[x, y] := NoWay;
						va10000: if Matrix[x, y] = NoWay then Matrix[x, y] := 10000;
						va10: if Matrix[x, y] = 10000 then Matrix[x, y] := 10;
						end
					else
						if (Matrix[x, y] <> 0) and (Matrix[x, y] <> NoWay) then
							AddMes('R' + NToS(x) + ' - ' + NToS(y))
						else
							Matrix[x, y] := NoWay;
				end;
			end;

			// Stupen vsech uzlu >= 2
			SolutionFound := False;
			Start[0] := 0; //Random(MaxXY + 1);
			StartCount := 1;
			MaxC := Low(MaxC);
//			if Variantion = vaNoWay then
			begin
				TotalC := 0;
				for y := 0 to MaxXY do
				begin
					C := 0;
					for x := 0 to MaxXY do
					begin
						if Matrix[x, y] <> NoWay then Inc(C);
					end;
					if C <= 1 then
					begin
						AddMes('Not Hamilton circle');
						goto LSkip;
					end;
					Inc(TotalC, C);
					if C = MaxC then
					begin
						if StartCount < 10 then
						begin
							Start[StartCount] := y;
							Inc(StartCount);
						end;
					end
					else
					if C > MaxC then
					begin
						MaxC := C;
						Start[0] := y;
						StartCount := 1;
					end;
				end;
				Tenuity := RoundDivU8(10000 * U8(TotalC), (MaxXY + 1) * MaxXY);
				AddMes(NToS(Tenuity, 2) + '% tenuity');
			end;
(*			// Poc. reseni
			Matrix[MaxXY + 1] := Matrix[Start];
			for i := 0 to MaxXY do
			begin
				Matrix[i, MaxXY + 1] := Matrix[i, Start];
			end;
			Target := MaxXY + 1;
			Inc(MaxXY); *)

			// Check symetic
			for y := 0 to MaxXY do
			for x := 0 to MaxXY do
				if Matrix[x, y] <> Matrix[y, x] then
				begin
					AddMes('Not Simetric');
					goto LSkip;
				end;

			// Create first solution
			NF := 0;
			PosCount := 0;
//		FillChar(Enableds2, SizeOf(Enableds2), 0);
			while StartCount > 0 do
			begin
				FillChar(Enableds, SizeOf(Enableds), 0);
				FillU4(Way, Length(Way), NoTown);
				WayCount := 0;
				WayValue := 0;
				BestValue := MaxInt;
				NowStart := Start[StartCount - 1];
				Actual := NowStart;
				Way[Actual] := NoTown;
				while True do
				begin
					Inc(PosCount);
					WorstNext := NoTown;
					WorstValue := MaxInt;
					BestNext := NoTown;
					BestValue := MaxInt;
					BestCount := 0;
					WorstCount := 0;
					for i := 0 to MaxXY do
					begin
						if i = Actual then Continue; // smycka
						Next := i;

						if Matrix[Actual, Next] = NoWay then
							Continue;

						EdgeValue := Matrix[Actual, Next];

						SolutionFound := (Next = NowStart) and (WayCount >= MaxXY);
						if (SolutionFound) or (Way[Next] = NoTown) then
						begin
							// prodlouzeni cesty
							if (BestNext = NoTown) or ((EdgeValue < BestValue) {and (Random(16) < 14)}) then
							begin
								BestNext := Next;
								BestValue := EdgeValue;
							end;
							Inc(BestCount);
							if (SolutionFound) then Break;
						end
						else
						begin
							if Way[Next] = Actual then
								Continue; // Predchudce cesty
							Inc(EdgeValue, 15000 * Enableds[Actual, Next]);
							if Enableds[Actual, Next] < 10 then
							if (WorstNext = NoTown) or ((EdgeValue < WorstValue){ or (Random(16) = 0)}) then
							begin
								WorstNext := Next;
								WorstValue := EdgeValue;
							end;
							Inc(WorstCount);
						end;
					end; // for i

					if BestNext <> NoTown then
					begin
						Way[Actual] := BestNext;
						Inc(WayCount);
						Inc(WayValue, BestValue);
						Actual := BestNext; // presun aktualniho
						// No edge found
						if SolutionFound then
						begin
							Break;
						end;
					end
					else // BestNext = NoTown
					begin
						if WorstNext = NoTown then Break; // No solution found
						Inc(Enableds[Actual, WorstNext]); // Proti zacykleni
						// Swap way
						Last := Actual;
						T0 := Actual;
						T1 := WorstNext;
						Actual := Way[T1];

						while True do
						begin
							T2 := Way[T1];
							Way[T1] := T0;
							if T1 = Last then Break;
							T0 := T1;
							T1 := T2;
						end;

						Way[Actual] := NoTown;
					end;
				end;
				if SolutionFound then
					Break
				else
				begin
					AddMes('Restarting WayCount=' + NToS(WayCount) + '/' + NToS(MaxXY + 1));
					Dec(StartCount);
//					Inc(NF); if NF >= 10 then Break;
				end;
			end;

			if WayValue = 0 then WayValue := MaxInt;

			StartWay := Way;
			StartWayValue := WayValue;

			// Okoli
			if SolutionFound then
			begin
				AddMes('Solution Found, Value = ' + NToS(WayValue));
				for Param := Low(ParamNameHTML) to Low(ParamNameHTML){High(ParamNameHTML)} do
				begin
					Beta := 0.92; // < 1
					MaxTemp := 40;
					MinTemp := 0.01;
					Inter := 8;
					case Param of
					paTMax:
					begin
						MaxTemp := 1000;
					end;
					paTMin:
					begin
						MinTemp := 1;
					end;
					paBeta:
					begin
						Beta := 0.7;
					end;
					paInter:
					begin
						Inter := 1;
					end;
					end;

					while True do
					begin
						for i := 0 to Length(ASeries) - 1 do
							ASeries[i].Clear;
						PosCountO := 0;
						PosCountV := 0;

						Way := StartWay;
						WayValue := StartWayValue;
						BestWayValue := WayValue;
						Zihani;
						AddMes('Best Solution is ' + NToS(BestWayValue));

						FileName := WorkDir + 'Graphs\Graph-' + FileNames[FileIndex] + '-' + VariantionNameFile[Variantion] +
							'-' + ParamNameFile[Param] + '.png';
						Bmp := TDBitmap.Create;
						Bmp.SetSize(Chart.ClientWidth, Chart.ClientHeight);
						Chart.Draw(Bmp.Canvas, Bmp.GetRect);
						Bmp.SaveToFile(FileName);

						HTML.AddBody('<tr>');
						HTML.AddDataCell(InternalName);
						HTML.AddDataCell(
							'<a href="' + 'Graphs/' + ExtractFileName(FileName) + '">' + VariantionNameHTML[Variantion] + '</a>', True);
						HTML.AddDataCell(NToHTML(MaxXY + 1), True);
						HTML.AddDataCell(FToHTML(Tenuity / 100), True);
						HTML.AddDataCell(FToHTML(MaxTemp), True);
						HTML.AddDataCell(FToHTML(MinTemp), True);
						HTML.AddDataCell(FToHTML(Beta), True);
						HTML.AddDataCell(NToHTML(Inter), True);
						HTML.AddDataCell(NToHTML(StartWayValue), True);
						HTML.AddDataCell(NToHTML(BestWayValue), True);

						HTML.AddDataCell(NToHTML(PosCount), True);
						HTML.AddDataCell(NToHTML(PosCountV), True);
						HTML.AddBody('</tr>');

						case Param of
						paTMax:
						begin
							MaxTemp := MaxTemp / 10;
							if MaxTemp < 1 then Break;
						end;
						paTMin:
						begin
							MinTemp := MinTemp / 10;
							if MinTemp < 0.001 then Break;
						end;
						paBeta:
						begin
							Beta := Beta + 0.05;
							if Beta >= 1 then Break;
						end;
						paInter:
						begin
							Inter := Inter * 10;
							if Inter > 100 then Break;
						end;
						else
							Break;
						end;
					end;
				end;
			end
			else
			begin
				AddMes('Solution not Found');
			end;

			LSkip:
		end;

	end;
	HTML.AddBody('</table>');
	HTML.Free;
	Chart.SeriesList.Clear;
	for i := 0 to Length(ASeries) - 1 do
		FreeAndNil(ASeries[i]);
end;

// ********************************* Knapsack *********************************

type
	TMethod = (
//		meBruteforce,
		meBorders,
		meDynamic,
		meHeurist);
//		meHeurist2);

const
	MethodN: array[TMethod] of string = (
//		'Bruteforce',
		'Borders',
		'Dynamic',
		'Heurist' // Greedy
{		'Heurist2'}); // Greedy2
	MethodN2: array[TMethod] of string = (
//		'Hrub sla',
		'Vtve a hranice',
		'Dynamick programovn',
		'Heuristika podle pomru cena/vha'
{		'Heuristika podle pomru cena'});

const
	Sep = ' ';
	MaxItems = 63;//40;
var
	// Settings
	n: SG;
	M: UG;
	Weights, Weights2: array[0..MaxItems] of UG;
	Prices, Prices2: array[0..MaxItems] of UG;
	PW: array[0..MaxItems] of UG;

	//
	RemPrice: array[0..MaxItems] of UG;
	MaxPrice: UG;
	NowDepth,
	NowWeight, NowPrice, NowItemCount,
	BestWeight, BestPrice, BestItemCount: UG;
	Used, BestUsed: array[0..MaxItems] of B1;

(*
		procedure Dep(LastItem: UG; MethodG: TMethod);
	var
		i: SG;
		NW: UG;
		Cont: BG;
	begin
		Inc(NowDepth);
		Inc(PosCount);
		for i := LastItem to n - 1 do
		begin
			NW := NowWeight + Weights[i];
			if NW > M then // Vec i v poradi nelze vlozit (pretizila by batoh)
			begin
				if MethodG in [meBruteforce, meBorders] then
					Break
				else
					Continue;
			end;

			// Insert item
			Used[i] := True;
			NowWeight := NW;
			Inc(NowPrice, Prices[i]);

			if NowPrice > BestPrice then // Dosazena nejlepsi cena
			begin
				BestWeight := NowWeight;
				BestPrice := NowPrice;
				BestItemCount := NowDepth;
				BestUsed := Used;
			end;

			// Test zda pokracovat
			Cont := i < n - 1; // pokracovat zbyva-li nejaka vec v poradi
			if Cont = True then
			if MethodG = meBorders then
			begin
				if NowPrice + RemPrice[i] <= BestPrice then
					Cont := False;
			end;

			if Cont then
				Dep(i + 1, MethodG);

			// Remove item
			Used[i] := False;
			Dec(NowWeight, Weights[i]);
			Dec(NowPrice, Prices[i]);

			if not (MethodG in [meBruteforce, meBorders]) then Break;
		end;

		Dec(NowDepth);
	end;
*)
	procedure Dep(MethodG: TMethod);
	label LNot;
	var
		NW: UG;
		Cont: BG;
	begin
		Cont := SG(NowDepth) < n - 1; // pokracovat zbyva-li nejaka vec v poradi

		NW := NowWeight + Weights[NowDepth];
		if NW > M then // Vec i v poradi nelze vlozit (pretizila by batoh)
		begin
//			if MethodG = meHeurist then IE(3445);
			goto LNot;
		end;

		// Insert item
		Used[NowDepth] := True;
		NowWeight := NW;
		Inc(NowPrice, Prices[NowDepth]);
		Inc(NowItemCount);

		if NowPrice > BestPrice then // Dosazena nejlepsi cena
		begin
			BestWeight := NowWeight;
			BestPrice := NowPrice;
			BestItemCount := NowItemCount;
			BestUsed := Used;
		end;
		Inc(PosCount);

		if Cont then
		begin
			Inc(NowDepth);
			Dep(MethodG);
			Dec(NowDepth);
		end;

		// Remove item
		Used[NowDepth] := False;
		Dec(NowWeight, Weights[NowDepth]);
		Dec(NowPrice, Prices[NowDepth]);
		Dec(NowItemCount);
		if MethodG in [meHeurist{, meHeurist2}] then Exit;

		LNot:
		// Test zda pokracovat
		if Cont = True then
		if MethodG = meBorders then
		begin
			if NowPrice + RemPrice[NowDepth] <= BestPrice then
				Cont := False;
		end;

		if Cont then
		begin
			Used[NowDepth] := False;
			Inc(NowDepth);
			Dep(MethodG);
			Dec(NowDepth);
		end;
		Inc(PosCount);


	end;

procedure TfMain.DButtonKanpsackClick(Sender: TObject);
var
	ItemIndex: SG;
	i, j: SG;
	x, y, nx, ny: SG;

	Lines: TStrings;
	LineIndex: SG;

	FileName: TFileName;
	Id: UG;
//	Output: string;
//	Output1, Output2: array[TMethod] of string;
	Tim, Clk: U8;


	AIndex: array of UG;

	// Stat
	HTML: THTML;
	MethodT: array[TMethod] of U8;
	MethodC: array[TMethod] of U8;
	MethodP: array[TMethod] of U8;
	ExactPrice: array[0..999] of U4;
	HeuristPrice: array[0..999] of U4;

	RealId: SG;
	Dif, SumDif, MaxDif: UG;
	DifR, SumDifR, MaxDifR: UG;

	// Dynamic
	Table: array of array[0..MaxItems] of U4;
	Method: TMethod;
	W: UG;

	Bmp: TDBitmap;
	ASeries: array[TMethod] of TLineSeries;
type
	TParam = (paSize, paW, paC, pam, pag, pae);
const
	ParamName: array[TParam] of Char = ('_'{n}, 'W', 'C', 'm', 'g', 'e');
	ParamNameCz: array[TParam] of string = (
		'velikosti instance',
		'maximln vze vci',
		'maximln cen vci',
		'pomru sumrn vhy ke kapacit batohu',
		'charakteru granularity',
		'exponent zvislosti granularity');
var
	FileNames: TFileNames;
	FileNamesCount: SG;
	FileIndex: SG;
var
	Param: TParam;
	s: string;
	ParamValue: Extended;
	Value: Double;
begin
	FileNamesCount := 0;
	ReadDir(FileNames, FileNamesCount, WorkDir + 'inst\', '.txt', True, False, False, False);
	for Param := Low(Param) to High(Param) do
	begin

	{	HTML := THTML.Create(WorkDir + 'Table3N.html');
		HTML.Title := 'Tabulka zvislosti vpoetnho asu na n';}

		HTML := THTML.Create(WorkDir + 'Table4' + ParamName[Param] + '.html');
		HTML.AddTitle := True;
		HTML.AddCreated := True;
		HTML.Title := 'Tabulka asov zvislosti / kvality een na ' + ParamNameCz[Param];

		HTML.AddBody('<table border="1">' + HTMLSep);
		HTML.AddBody('<tr>' +
			'<td></td>');
		for Method := Low(Method) to High(Method) do
		begin
			if Method = meHeurist then i := 4 else i := 3;
			HTML.AddBody(
			'<td colspan=' + IntToStr(i) + '><b>' + MethodN2[Method] + '</b></td>');
		end;
		HTML.AddBody(
			'</tr>' + HTMLSep);
		HTML.AddBody('<tr>');
		HTML.AddBody(
			'<td align="right"><b>' + ReplaceF(ParamName[Param], '_', 'n') + '</b></td>');
		for Method := Low(Method) to High(Method) do
		begin
			if Method = meHeurist then
				HTML.AddBody(
				'<td align="right"><b>&Oslash; Zhoren</b></td>' +
				'<td align="right"><b>&Oslash; Zhoren [%]</b></td>' +
				'<td align="right"><b>Max. zhoren</b></td>' +
				'<td align="right"><b>Max. zhoren [%]</b></td>')
			else
				HTML.AddBody(
				'<td align="right"><b>Instr.</b></td>' +
				'<td align="right"><b>as [s]</b></td>' +
				'<td align="right"><b>Uzly</b></td>');
		end;
		HTML.AddBody('</tr>' + HTMLSep);

		// Read
		for Method := Low(Method) to High(Method) do
		begin
			ASeries[Method] := TLineSeries.Create(Self);
			ASeries[Method].Title := MethodN2[Method];
			ASeries[Method].Pointer.Visible := True;
			ASeries[Method].Pointer.Style := psTriangle;
		end;
		for FileIndex := 0 to FileNamesCount - 1 do
		begin
			FileName := WorkDir + 'inst\' + FileNames[FileIndex];
			s := DelFileExt(ExtractFileName(FileName));
			i := Pos('knap' + ParamName[Param], s);
			if i = 0 then Continue;
			ParamValue := StrToValE(Copy(s, i + 4 + Length(ParamName[Param]), MaxInt), False, -MaxInt, 0, MaxInt);
			if Param in [pam, pae] then ParamValue := ParamValue / 10;

			Lines := TStringList.Create;
			ReadLinesFromFile(FileName, Lines);

			for Method := Low(Method) to High(Method) do
			begin
				MethodT[Method] := 0;
				MethodC[Method] := 0;
				MethodP[Method] := 0;
			end;
			RealId := 0;
			SumDif := 0;
			MaxDif := 0;
			SumDifR := 0;
			MaxDifR := 0;
			for j := 0 to Lines.Count - 1 do
			begin
				LineIndex := 1;
				Id := StrToValI(ReadToChar(Lines[j], LineIndex, Sep), False, 0, 0, MaxInt, 1);
				n := StrToValI(ReadToChar(Lines[j], LineIndex, Sep), False, 0, 0, MaxInt, 1);
//				if n <> ItemCount[ItemIndex] then IE(545);
				M := StrToValI(ReadToChar(Lines[j], LineIndex, Sep), False, 0, 0, MaxInt, 1);

				for i := 0 to n - 1 do
				begin
					Weights2[i] := StrToValI(ReadToChar(Lines[j], LineIndex, Sep), False, 0, 0, MaxInt, 1);
					Prices2[i] := StrToValI(ReadToChar(Lines[j], LineIndex, Sep), False, 0, 0, MaxInt, 1);
				end;

				for Method := Low(TMethod){High(TMethod)} to High(TMethod) do
				begin
//					if (Method in [meBruteforce]) and (ItemCount[ItemIndex] >= 27{29-15min}{31-1h}) then Continue; // Too long time
	//				if (Method in [meBorders]) and (ItemCount[ItemIndex] >= 31) then Continue; // Too long time


					// Calc
					NowDepth := 0;
					PosCount := 0;

					NowWeight := 0;
					NowPrice := 0;
					FillChar(Used, SizeOf(Used), 0);

					BestWeight := NowWeight;
					BestPrice := NowPrice;
					BestItemCount := NowDepth;
					BestUsed := Used;


					// Start timer
					Tim := PerformanceCounter;
					Clk := GetCPUCounter.A;
					PosCount := 0;


					// Sort
					SetLength(AIndex, 0);
					SetLength(AIndex, n);
					for i := 0 to n - 1 do
						AIndex[i] := i;

//					if Method <> meHeurist then
					begin
						// Podle cena/vaha
						for i := 0 to n - 1 do
							PW[i] := RoundDiv(Prices2[i] shl 8, Weights2[i]);

						SortU4(False, True, PArraySG(@AIndex[0]), PArrayU4(@PW[0]), n);

	//					Weights := Weights2;
						for i := 0 to n - 1 do
							Weights[i] := Weights2[AIndex[i]];

	//					Prices2 := Prices;
						for i := 0 to n - 1 do
							Prices[i] := Prices2[AIndex[i]];
					end;
//					else
	{				begin
						// Podle vahy
						Weights := Weights2;
						SortU4(False, False, PArraySG(@AIndex[0]), PArrayU4(@Weights[0]), n);
						for i := 0 to n - 1 do
							Prices[i] := Prices2[AIndex[i]];
					end;
					begin
						// Podle ceny
						Prices := Prices2;
						SortU4(False, True, PArraySG(@AIndex[0]), PArrayU4(@Prices[0]), n);
						for i := 0 to n - 1 do
							Weights[i] := Weights2[AIndex[i]];
					end;}
	{				begin
						// None
						for i := 0 to n - 1 do
						begin
							Weights[i] := Weights2[i];
							Prices[i] := Prices2[i];
						end;
					end;}

					MaxPrice := 0;
					for i := n - 1 downto 0 do
					begin
						RemPrice[i] := MaxPrice;
						Inc(MaxPrice, Prices[i]);
					end;


					if Method = meDynamic then
					begin
						SetLength(Table, MaxPrice + 1);
						for i := 0 to MaxPrice do
						begin
							FillChar(Table[i], SizeOf(Table[i]), $ff);
						end;
					end;

					if Method = meDynamic then
					begin
						Table[0, 0] := 0;
						for x := 1 to n do
						for y := 0 to MaxPrice do
						begin
							nx := x - 1;
							ny := y - SG(Prices[nx]);
							W := 0;
							if ny >= 0 then
							begin
								if Table[ny, nx] <> $ffffffff then
								if Table[y, x] > Table[ny, nx] + Weights[nx] then
								begin
									W := Table[ny, nx] + Weights[nx];
									Table[y, x] := W; // Je tam
								end;
							end;
							if Table[y, nx] <> $ffffffff then
							if Table[y, x] > Table[y, nx]  then
							begin
								W := Table[y, nx];
								Table[y, x] := W; // Neni tam
							end;
							Inc(PosCount);
							if W <= M then // Legal
							begin
								if Table[y, x] <> $ffffffff then
								if x = n then
								begin
									BestWeight := W;
									BestPrice := y;
								end;
							end;
						end;
						// Extract solution
						BestItemCount := 0;

						y := BestPrice;
						for x := n downto 1 do
						begin
							if Table[y, x - 1] = Table[y, x] then
							begin

							end
							else
							begin
								Inc(BestItemCount);
								y := y - SG(Prices[x - 1]);
							end;
						end;
					end
					else
					begin
						Dep(Method);
					end;

					Clk := GetCPUCounter.A - Clk;
					Tim := PerformanceCounter - Tim;
					Inc(MethodT[Method], Tim);
					Inc(MethodC[Method], Clk);
					Inc(MethodP[Method], PosCount);

					if Method = meDynamic then
						ExactPrice[RealId] := BestPrice;
					if Method = meHeurist then
						HeuristPrice[RealId] := BestPrice;

//					Output1[Method] := Output1[Method] + IntToStr(Id) + Sep + IntToStr(BestItemCount) + Sep + IntToStr(BestPrice) + FullSep;
	{				Output := Output + 'Time: ' + NToS(RoundDivU8(1000000 * Tim, PerformanceFrequency), 6) + FullSep;
					Output := Output + 'Pos: ' + NToS(PosCount) + FullSep;}
				end; // Method

				Dif := ExactPrice[RealId] - HeuristPrice[RealId];
				if Dif = 0 then
					DifR := 0
				else
					DifR := RoundDiv(10000 * Dif, ExactPrice[RealId]);

				if Dif > MaxDif then MaxDif := Dif;
				if DifR > MaxDifR then MaxDifR := DifR;

				Inc(SumDif, Dif);
				Inc(SumDifR, DifR);

				Inc(RealId);
			end; // Instance

			HTML.AddBody(
				'<tr><td align="right">' + FToS(ParamValue) + '</td>');
//			UseNA := True;
			for Method := Low(Method) to High(Method) do
			begin
				if Method = meHeurist then
				begin
					HTML.AddBody(
						'<td align="right">' + NToS(RoundDiv(10 * SumDif, RealId), 1) + '</td>' +
						'<td align="right">' + NToS(RoundDiv(SumDifR, RealId), 2) + '</td>' +
						'<td align="right">' + NToS(MaxDif) + '</td>' +
						'<td align="right">' + NToS(MaxDifR, 2) + '</td>');
					Value := 10 * SumDifR / RealId;
				end
				else
				begin
					HTML.AddBody(
						'<td align="right"><small>' + NToS(RoundDivU8(MethodC[Method], Lines.Count)) + '</small></td>' +
						'<td align="right"><small>' + NToS(RoundDivU8(1000000 * MethodT[Method], Lines.Count * PerformanceFrequency), 6) + '</small></td>' +
						'<td align="right">' + NToS(MethodP[Method]) + '</td>');
					Value := MethodP[Method];
				end;

//				Output2[Method] := Output2[Method] + IntToStr(n) + CharTab + IntToStr(RoundDivU8(MethodP[Method], Lines.Count)) + FullSep;
//				Output := Output + 'Total Time: ' + NToS(RoundDivU8(1000000 * MethodT[Method], Lines.Count * PerformanceFrequency), False, 6) + FullSep;
				ASeries[Method].AddXY(ParamValue, Value);
			end;
//			UseNA := False;
			HTML.AddBody(
				'</tr>' + HTMLSep);

			Lines.Free;
		end;
		Chart.ClientWidth := 800;
		Chart.ClientHeight := 600;
		Chart.SeriesList.Clear;
		for Method := Low(Method) to High(Method) do
		begin
			Chart.AddSeries(ASeries[Method]);
		end;
		Chart.LeftAxis.Title.Caption := 'Uzly / zhoren';
		Chart.BottomAxis.Title.Caption := ReplaceF(ParamName[Param], '_', 'n');
		Bmp := TDBitmap.Create;
		Bmp.SetSize(Chart.ClientWidth, Chart.ClientHeight);
		Chart.Draw(Bmp.Canvas, Bmp.GetRect);
		FileName := WorkDir + 'Graph4' + ParamName[Param] + '.png';
		Bmp.SaveToFile(FileName);

		HTML.AddBody('</table>' + HTMLSep);
		HTML.AddBody('<br/>' + HTMLSep);
		HTML.AddBody('<br/>' + HTMLSep);
		HTML.AddImage(FileName);
		HTML.Free;

		// Calc
{		for Method := Low(Method) to High(Method) do
		begin
			FileName := DataDir + MethodN[Method] + '.txt';
			WriteStringToFile(FileName, Output2[Method], False);
			FileName := DataDir + 'Output' + MethodN[Method] + '.txt';
			WriteStringToFile(FileName, Output1[Method], False);
		end;}

		// Compare Bruteforce/Selective/Heurist


//		HTML := THTML.Create(WorkDir + 'Table3.html');
(*		HTML.AddBody('<h2>Tabulka prmrnho zhoren proti exaktn metod</h2>' + HTMLSep);
		HTML.Title := 'Tabulka porovnn dosaen ceny exaktn metody a heuristiky';
		HTML.AddBody('<table border="1">' + HTMLSep);
		HTML.AddBody('<tr>' +
			'<td><b>Id</b></td>' +
			'<td align="right"><b>n</b></td>' +
			'<td align="right"><b>Exaktn metoda</b></td>' +
			'<td align="right"><b>Heuristika</b></td>' +
			'<td align="right"><b>Zhoren</b></td>' +
			'<td align="right"><b>Zhoren [%]</b></td>' +
			'</tr>' + HTMLSep);*)

{		Chart.SeriesList.Clear;
		ASeries := TLineSeries.Create(Self);}

(*		RealId := 0;
		SumDif := 0;
		MaxDif := 0;
		SumDifR := 0;
		MaxDifR := 0;
		for FileIndex := 0 to FileNamesCount - 1 do
		begin
{		for ItemIndex := 0 to Length(ItemCount) - 1 do
		begin
			Lines := TStringList.Create;
			FileName := WorkDir + 'sol\knap_' + IntToStr(ItemCount[ItemIndex]) + '.txt';
			ReadLinesFromFile(FileName, Lines);

			for j := 0 to Lines.Count - 1 do
			begin
				LineIndex := 1;
				Id := StrToValI(ReadToChar(Lines[j], LineIndex, Sep), False, 0, 0, MaxInt, 1);
				n := StrToValI(ReadToChar(Lines[j], LineIndex, Sep), False, 0, 0, MaxInt, 1);
				if n <> ItemCount[ItemIndex] then IE(545);
				M := StrToValI(ReadToChar(Lines[j], LineIndex, Sep), False, 0, 0, MaxInt, 1);}
				Id := 0;
				Dif := {M}ExactPrice[RealId] - HeuristPrice[RealId];
				DifR := RoundDiv(1000 * (Dif), M);

				if Dif > MaxDif then MaxDif := Dif;
				if DifR > MaxDifR then MaxDifR := DifR;

				Inc(SumDif, Dif);
				Inc(SumDifR, DifR);

				HTML.AddBody(
					'<tr><td>' +
					NToS(Id) + '</td><td align="right">' +
					NToS(n) + '</td><td align="right">' +
					NToS(M) + '</td><td align="right">' +
					NToS(HeuristPrice[RealId]) + '</td><td align="right">' +
					NToS(Dif) + '</td><td align="right">' +
					NToS(DifR, 1) + '%</td>' +
					'</tr>' + HTMLSep);
				Inc(RealId);
//				ASeries.AddXY()
{			end;}
		end;

		Output := Output + 'Prmrn zhoren: ' + NToS(RoundDiv(10 * SumDif, RealId), 1)  + ', ' + NToS(RoundDiv(10 * SumDifR, RealId), 2) + '%' + FullSep;
		Output := Output + 'Maximln zhoren: ' + NToS(MaxDif) + ', ' + NToS(MaxDifR, 1) + '%';}

{		HTML.AddBody('</table>' + HTMLSep + '<br/>' + HTMLSep);

		HTML.AddBody('Prmrn zhoren: ' + NToS(RoundDiv(10 * SumDif, RealId), 1)  + ', ' + NToS(RoundDiv(10 * SumDifR, RealId), 2) + '%<br/>' + HTMLSep);
		HTML.AddBody('Maximln zhoren: ' + NToS(MaxDif) + ', ' + NToS(MaxDifR, 1) + '%<br/>' + HTMLSep);}

		HTML.WriteToFile;
		HTML.Free;


//		AddMes(Output);*)
	end; // Param
	SetLength(FileNames, 0);
end;

// ********************************** Vessel **********************************

const
	scNone = $ffff;
	scRepeat = $ffff - 1;

type
	TStatus = (stNone, stOpened, stUsed);

	THash = packed record // 8
		Score: U2;
		ScoreU: U1;
		ScoreD: U1;
		Status: TStatus;
		DepthU: U1;
		DepthA: U1;
		DepthD: U1; // Realy used
	end;
	PHashTable = ^THashTable;
	THashTable = array[0..128 * 1024 * 1024 - 1] of THash;
var
	HashTable: PHashTable;

	HashIn, HashC: UG;
	HashCount: UG;

procedure TfMain.DButtonVesselClick(Sender: TObject);
const
	MaxD = 31;
	VesselCount = 5;
type
	TV = array[0..VesselCount - 1] of UG;
var
	Heurist: SG;
	VMax, V, VWant, VShl: TV;

	VT: SG;
	BestVD: UG;
	BestV, HV: array[0..MaxD] of TV;
	BestVT, HVT: array[0..MaxD] of SG;
	Scores: array[0..MaxD] of U4;
	BestScores: array[1..MaxD] of U4;
	ContA: array[0..MaxD] of U1;

	NowDepth, MaxDepth: SG;
	TotalPosCount, PosCount: SG;

	procedure Dep;
	label LCont, LExit, LNext;
	var
		Score: U4;
		ScoreU: U1;
		ScoreD: U1;
		HashI: UG;
		i, d, So, De, MaxDe: SG;
//		Op: (opTran, opEmpty, opFill); // 195
//		Op: (opTran, opFill, opEmpty); // 195
//		Op: (opEmpty, opTran, opFill); // 200
		Op: (opTran, opFill, opEmpty); // 193
		Cont: U1;
	begin
		Inc(NowDepth);
		BestScores[NowDepth] := scNone;
		for Op := Low(Op) to High(Op) do
		begin
			case Op of
			opTran:
			begin
				MaxDe := VesselCount - 1;
				if ContA[NowDepth - 1] = 1 then Continue;
			end
			else
			begin
				MaxDe := 0;
				if ContA[NowDepth - 1] = 2 then
				begin
					Continue;
				end;
{				if MaxDepth - NowDepth < 0 then
					Break;}
			end;
			end;
			for De := 0 to MaxDe do
			for So := 0 to VesselCount - 1 do
			begin
{				if V[0] <> HV[NowDepth - 1][0] then
					IE(5454); }
				V := HV[NowDepth - 1];
				case Op of
				opTran: // V[So] -> V[De]
				begin
					if V[So] = 0 then goto LCont;
					if V[De] = VMax[De] then Continue;
	//					if V[k] + V[j] > VMax[k] then goto LCont;
					if V[So] <= VMax[De] - V[De] then
					begin
						Inc(V[De], V[So]);
						V[So] := 0;
					end
					else
					begin
						Dec(V[So], VMax[De] - V[De]);
						V[De] := VMax[De];
					end;

				end;
				opEmpty: // V[So] -> Out
				begin
					if V[So] = 0 then goto LCont;
					V[So] := 0;
				end;
				opFill: // Source -> V[So]
				begin
					if V[So] = VMax[So] then goto LCont;
					if VMax[So] < V[So] then
						IE(4340);
					Dec(VT, VMax[So] - V[So]);
					V[So] := VMax[So];
				end;
				end;

				Inc(PosCount);
				if (NowDepth < MaxDepth) then
					Cont := 255
				else
					Cont := 0;

				// Calc Hash
				HashI := 0;
				for i := 0 to VesselCount - 1 do
				begin
					HashI	:= HashI + V[i] shl VShl[i];
				end;
				if HashI >= HashCount then
				begin
					IE(4343);
				end;

				ScoreU := 0;
				ScoreD := 0;
				if (HashTable[HashI].Status = stOpened) then
				begin
					Score := scRepeat;
					goto LNext;
				end
				else if (HashTable[HashI].Status = stNone) then
				begin
					Inc(PosCount);
					Score := 0;
{					ScoreU := 0;
					ScoreD := 0;}
					for i := 0 to VesselCount - 1 do
					begin
						d := SG(V[i]) - SG(VWant[i]);
						if d > 0 then
						begin
							Inc(ScoreU);
							Inc(Score, d);
						end
						else if d < 0 then
						begin
							Inc(ScoreD);
							Inc(Score, -d);
						end;
					end;
					{$ifopt d+}
					if (Score = 0) and (NowDepth < 3) then
						IE(45411);
					{$endif}
					HashTable[HashI].Status := stUsed;
					HashTable[HashI].Score := Score;
					HashTable[HashI].ScoreU := ScoreU;
					HashTable[HashI].ScoreD := ScoreD;
					HashTable[HashI].DepthD := Max(0, MaxDepth - NowDepth);
					HashTable[HashI].DepthA := MaxDepth;
					HashTable[HashI].DepthU := NowDepth;
					Inc(HashIn);
				end
				else
				begin
					Score := HashTable[HashI].Score;
					ScoreU := HashTable[HashI].ScoreU;
					ScoreD := HashTable[HashI].ScoreD;
					if HashTable[HashI].DepthD >= MaxDepth - NowDepth then
					begin
//						Cont := 0;
						goto LNext;
					end;

{not exact					if Heurist > 1 then
					if HashTable[HashI].DepthA < MaxDepth then
					begin
						HashTable[HashI].DepthA := MaxDepth;
						if HashTable[HashI].DepthD >= MaxDepth - NowDepth then
						begin
							Cont := False;
						end;
					end
					else
					begin
						if Cont then
						if HashTable[HashI].DepthU <= NowDepth then
						begin
							Cont := False;
						end;
					end;}

				end;

				if Heurist > 0 then
				if MaxDepth - NowDepth > 0 then
				begin

{	dnw				if Heurist > 1 then
						if SG(Score) > 27 * (MaxDepth - NowDepth) then Cont := False; // Exact Heurist XXXXXXXXX}

					if (ScoreU + ScoreD + 1) div 2 > (MaxDepth - NowDepth) then
					begin
						Cont := 0; // Exact Heurist
//						goto LNext;
					end;
					if (ScoreU) > (MaxDepth - NowDepth) then
					begin
						Cont := 0; // Exact Heurist
//						goto LNext;
					end;
					if (ScoreD) > (MaxDepth - NowDepth) then
					begin
						Cont := 0; // Exact Heurist
//						goto LNext;
					end;


{	bad				if Heurist > 1 then
						if Score > 14 * (MaxDepth - NowDepth) then Cont := False;}
{ bad
					if Heurist > 1 then
					if MaxDepth - NowDepth = 1 then
					if Score > Scores[NowDepth - 1] then // Good move
					begin
						Cont := True;
					end;}
				end;


				if Heurist > 1 then
				begin
					if (MaxDepth - NowDepth >= -1) then
					begin
						if (ScoreU + ScoreD = 1) then Cont := 1;
						if (ScoreU = 1) and (ScoreD = 1) then Cont := 2;
					end;
{				if MaxDepth - NowDepth > -9 then
					if Score < Scores[NowDepth - 1] then // Good move
					begin
						Cont := True;
					end;}
{				 if NowDepth >= MaxDepth then
					if (SG(Scores[NowDepth - 1]) - Score) > 6 * (NowDepth - MaxDepth) + 3 then // Good move
					begin
						Cont := True;
					end;}
{				if MaxDepth - NowDepth = 0 then
					if Score < Scores[NowDepth - 1] then // Good move
					begin
						Cont := True;
					end;}
{				if MaxDepth - NowDepth = 0 then
					if Score < Scores[NowDepth - 1] then // Good move
					begin
						Cont := True;
					end;}
				end;


	{			Found := True;
				for i := 0 to VesselCount - 1 do
				begin
					if V[i] <> VWant[i] then
					begin
						Found := False;
						Break;
					end;
				end;}
				if (Score = 0) and (NowDepth < 3) then
					IE(4543);
				if Score = scNone then
					IE(454);
				if (NowDepth = MaxD) then Cont := 0;

				if (Score = 0) then
				begin
					BestV[NowDepth] := V;
					BestVT[NowDepth] := VT;
					BestVD := NowDepth;
					if (NowDepth < 3) then
						IE(43422);
				end
				else if Cont > 0 then
				begin
					HV[NowDepth] := V;
					HVT[NowDepth] := VT;
					HashTable[HashI].Status := stOpened;
					Scores[NowDepth] := Score;
					ContA[NowDepth] := Cont;
					Dep;
					Score := BestScores[NowDepth + 1];
					HashTable[HashI].Score := Score;
					HashTable[HashI].Status := stUsed;
					HashTable[HashI].DepthD := Max(0, MaxDepth - NowDepth);
				end;

				LNext:
				if Score < BestScores[NowDepth] then
				begin
					BestScores[NowDepth] := Score;
					if BestScores[NowDepth] = 0 then
					begin
//						if Cont > 0 then
							BestV[NowDepth] := HV[NowDepth];
							BestVT[NowDepth] := HVT[NowDepth];
//							BestVD := NowDepth;
					end;
					if BestScores[NowDepth] = 0 then goto LExit;
				end;
				LCont:
				V := HV[NowDepth - 1];
				VT := HVT[NowDepth - 1];
			end;
		end;

		LExit:
		Dec(NowDepth);
	end;

var
	Lines: TStrings;
	FileName: TFileName;
	InLineIndex: SG;
	i, j, k, c: SG;
	s: string;
	HTML: THTML;
begin
	Lines := TStringList.Create;
	FileName := WorkDir + 'Data\Vessel.txt';
	ReadLinesFromFile(FileName, Lines);

	HTML := THTML.Create('Problem2Table.html');
	HTML.Title := 'Tabulka dlky cesty k een a poetu navtvench bod stavovho prostoru';
	HTML.AddBody('<p>' + HTMLSep);
	HTML.AddBody(ReadStringFromFile(WorkDir + 'Problem2Table.txt'));
	HTML.AddBody('</p>' + HTMLSep);
	HTML.AddBody('<table border="1">' + HTMLSep);
	HTML.AddBody(
		'<tr>' +
		'<td rowspan=2><b>Dlka cesty k een</b></td>' +
		'<td colspan=2><b>Uzly stavovho prostoru</b></td>' +
		'<td rowspan=2><b>Poet prchod bod stavovho prostoru</b></td>' +
		'</tr>' + HTMLSep);
	HTML.AddBody(
		'<tr>' +
		'<td><b>Poet navtvench</b></td>' +
		'<td><b>Celkem</b></td>' +

		'</tr>' + HTMLSep
	);

	TotalPosCount := 0;
	j := 0;
	while True do
	begin
		if Lines[j] = '' then Inc(j);
		if j >= Lines.Count then Break;
		// VMax
		s := Lines[j];
		InLineIndex := 1;
		k := 0;
		HashC := 1;
		for i := 0 to VesselCount - 1 do
		begin
			VMax[i] := StrToValI(ReadToChar(s, InLineIndex, ' '), False, 0, 0, MaxInt, 1);
			VShl[i] := k;
			HashC := HashC * (VMax[i] + 1);
			Inc(k, CalcShr(VMax[i] + 1));
		end;
		HashCount := 1 shl k;
		GetMem(HashTable, HashCount * SizeOf(THash));
		Inc(j);

		s := Lines[j];
		InLineIndex := 1;
		for i := 0 to VesselCount - 1 do
		begin
			V[i] := StrToValI(ReadToChar(s, InLineIndex, ' '), False, 0, 0, MaxInt, 1);
		end;
		Inc(j);

		for i := 0 to VesselCount - 1 do
		begin
			HV[0][i] := V[i];
		end;

		while True do
		begin
			s := Lines[j];
			if s = '' then Break;
			InLineIndex := 1;
			for i := 0 to VesselCount - 1 do
			begin
				VWant[i] := StrToValI(ReadToChar(s, InLineIndex, ' '), False, 0, 0, MaxInt, 1);
			end;
			Inc(j);

			for Heurist := 0 to 2 do
			begin
				FillChar(HashTable^, HashCount * SizeOf(THash), 0);
				HashIn := 0;
				Scores[0] := MaxInt;

				PosCount := 0;
				for MaxDepth := 1 to MaxD do
				begin
		{			HVT[0] := 0;
					VT := 0;}
					BestVD := 0;
					NowDepth := 0;
					ContA[0] := 255;
					Dep;
		//			AddMes('Depth: ' + NToS(MaxDepth));
					AddMes('BestScore: ' + NToS(BestScores[MaxDepth]));
					AddMes('PosCount: ' + NToS(PosCount));
		//			AddMes('Found solution:');
		//			AddMes('PosCount ' + IntToStr(PosCount));
					AddMes('Depth ' + IntToStr(MaxDepth));
					for i := 1 to BestVD do
					begin
						s := '';
						for k := 0 to VesselCount - 1 do
						begin
							s := s + IntToStr(BestV[i][k]) + ',';
						end;

						AddMes(s + '(' + IntToStr(BestVT[i]) + ')');

					end;
					if BestScores[1] = 0 then
					begin
						HTML.AddBody(
							'<tr>' +
							'<td align="right">' + NToS(BestVD) + '</td>' +
							'<td align="right">' + NToS(HashIn) + '</td>');
						if Heurist = 0 then
						begin
							HTML.AddBody(
								'<td align="right" rowspan=3>' + NToS(HashC) + '</td>');
						end;
						HTML.AddBody(
							'<td align="right">' + NToS(PosCount) + '</td>' +
							'</tr>' + HTMLSep);
						Break;
					end;
				end;
				Inc(TotalPosCount, PosCount);
				AddMes('HashIn ' + IntToStr(HashIn) + '/' + IntToStr(HashC));

				// Check Hash
				c := 0;
				for i := 0 to HashCount - 1 do
				begin
					case HashTable[i].Status of
					stNone:
					begin

					end;
					stUsed:
					begin
						Inc(c);
					end
					else
						IE(465);
					end;
				end;
				AddMes('ds' + NToS(c));
				AddMes('********');
			end;
//		Break;
		end;
		FreeMem(HashTable, HashCount);
		HashTable := nil;
		AddMes('~~~~~*******************');
//		Break;
	end;
	HTML.AddBody('</table>');
	HTML.Free;
	AddMes('TotalPosCount: ' + NToS(TotalPosCount));
	Lines.Free;
end;

// TfMain

procedure TfMain.FormCreate(Sender: TObject);
begin
	Background := baStandard;
	ImagesDir := WorkDir + 'images/';
end;

procedure TfMain.AddMes(Mes: string);
begin
	MemoMes.Lines.Add(Mes);
	Application.ProcessMessages;
end;

procedure TfMain.FormResize(Sender: TObject);
begin
	MemoMes.Width := ClientWidth - MemoMes.Left - FormBorder;
	MemoMes.Height := ClientHeight - 2 * MemoMes.Top;
end;

end.
